class Sequence {
	volatile private int n = 0;
	public int next() {
		return ++n;
	}
}

class Worker extends Thread {
	private Sequence s;
	public Worker(Sequence s) {
		this.s = s;
	}
	public void run() {
		for (int i = 0; i < 100; i++) {
			int seqno = s.next();
			/* ... */
		}
	}
}

class Main {
	private final static int N_THREADS = 100;
	public static void main(String[] args) 
		throws InterruptedException {
		Worker[] w = new Worker[N_THREADS];
		Sequence s = new Sequence();
		for (int i = 0; i < N_THREADS; i++) {
			w[i] = new Worker(s);
			w[i].start();
		}
		for (int i = 0; i < N_THREADS; i++) {
			w[i].join();
		}
		System.out.println("Nächste Nummer: " + s.next());
	}
}