#include <iostream>

class O {
private:
	std::string explanation;
	
public:
	O(std::string explanation);
	void explain();
};

class U : public O {
public:
	U(std::string explanation);
	void explain();
};

O::O(std::string explanation) : explanation(explanation) {}

void O::explain() {
	std::cout << explanation << std::endl;
}

U::U(std::string explanation) : O(explanation) {}

void U::explain() {
	std::cout << "Der Fehler ist: ";
	O::explain();
}

int f(int i) {
	if (i > 10) throw U("Argument zu groß");
	if (i <= 0) return 1;
	return i * f(i-1);
}

int main() {
	try {
		std::cout << f(5) << std::endl;
		std::cout << f(-2) << std::endl;
		std::cout << f(11) << std::endl;
		std::cout << f(2) << std::endl;
		std::cout << f(2) << std::endl;
	} catch (O o) {
		o.explain();
	}
	return 0;
}